# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from luminarycloud._proto.api.v0.luminarycloud.solution import solution_pb2 as proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2


class SolutionServiceStub(object):
    """API for retrieving simulation solutions. The surface and volume solutions are
    available as subresources of each Solution.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.ListSolutions = channel.unary_unary(
                '/luminary.proto.api.v0.luminarycloud.solution.SolutionService/ListSolutions',
                request_serializer=proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.ListSolutionsRequest.SerializeToString,
                response_deserializer=proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.ListSolutionsResponse.FromString,
                )
        self.GetSolutionSurfaceData = channel.unary_unary(
                '/luminary.proto.api.v0.luminarycloud.solution.SolutionService/GetSolutionSurfaceData',
                request_serializer=proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.GetSolutionSurfaceDataRequest.SerializeToString,
                response_deserializer=proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.GetSolutionSurfaceDataResponse.FromString,
                )
        self.GetSolutionVolumeData = channel.unary_unary(
                '/luminary.proto.api.v0.luminarycloud.solution.SolutionService/GetSolutionVolumeData',
                request_serializer=proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.GetSolutionVolumeDataRequest.SerializeToString,
                response_deserializer=proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.GetSolutionVolumeDataResponse.FromString,
                )


class SolutionServiceServicer(object):
    """API for retrieving simulation solutions. The surface and volume solutions are
    available as subresources of each Solution.
    """

    def ListSolutions(self, request, context):
        """Retrieves a list of the available solutions for a simulation in ascending
        order of iteration.
        If the simulation is still running, more solutions may become available
        as it runs to completion.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def GetSolutionSurfaceData(self, request, context):
        """Retrieves surface fields data, compresses them and returns bytes to the caller in multiple chunks.
        The caller may need to send multiple requests to receive the full contents, or may need to fetch the contents via
        a provided signed URL. The caller can write this data to a persistent file storage and use for further processing.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def GetSolutionVolumeData(self, request, context):
        """Outputs the volume data for a solution as a compressed archive file. Returns bytes to the caller in multiple chunks.
        The caller may need to send multiple requests to receive the full contents, or may need to fetch the contents via
        a provided signed URL. The caller can write this data to a persistent file storage and use for further processing.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_SolutionServiceServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'ListSolutions': grpc.unary_unary_rpc_method_handler(
                    servicer.ListSolutions,
                    request_deserializer=proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.ListSolutionsRequest.FromString,
                    response_serializer=proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.ListSolutionsResponse.SerializeToString,
            ),
            'GetSolutionSurfaceData': grpc.unary_unary_rpc_method_handler(
                    servicer.GetSolutionSurfaceData,
                    request_deserializer=proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.GetSolutionSurfaceDataRequest.FromString,
                    response_serializer=proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.GetSolutionSurfaceDataResponse.SerializeToString,
            ),
            'GetSolutionVolumeData': grpc.unary_unary_rpc_method_handler(
                    servicer.GetSolutionVolumeData,
                    request_deserializer=proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.GetSolutionVolumeDataRequest.FromString,
                    response_serializer=proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.GetSolutionVolumeDataResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'luminary.proto.api.v0.luminarycloud.solution.SolutionService', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class SolutionService(object):
    """API for retrieving simulation solutions. The surface and volume solutions are
    available as subresources of each Solution.
    """

    @staticmethod
    def ListSolutions(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/luminary.proto.api.v0.luminarycloud.solution.SolutionService/ListSolutions',
            proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.ListSolutionsRequest.SerializeToString,
            proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.ListSolutionsResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def GetSolutionSurfaceData(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/luminary.proto.api.v0.luminarycloud.solution.SolutionService/GetSolutionSurfaceData',
            proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.GetSolutionSurfaceDataRequest.SerializeToString,
            proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.GetSolutionSurfaceDataResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def GetSolutionVolumeData(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/luminary.proto.api.v0.luminarycloud.solution.SolutionService/GetSolutionVolumeData',
            proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.GetSolutionVolumeDataRequest.SerializeToString,
            proto_dot_api_dot_v0_dot_luminarycloud_dot_solution_dot_solution__pb2.GetSolutionVolumeDataResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
