"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Metadata definition for *.lcsoln files. They store FVM solutions."""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import luminarycloud._proto.quantity.quantity_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _AuxSolnFileType:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _AuxSolnFileTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_AuxSolnFileType.ValueType], builtins.type):  # noqa: F821
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    INVALID_AUX_SOLN_FILE_TYPE: _AuxSolnFileType.ValueType  # 0
    DISK_SOLN_V1: _AuxSolnFileType.ValueType  # 2

class AuxSolnFileType(_AuxSolnFileType, metaclass=_AuxSolnFileTypeEnumTypeWrapper): ...

INVALID_AUX_SOLN_FILE_TYPE: AuxSolnFileType.ValueType  # 0
DISK_SOLN_V1: AuxSolnFileType.ValueType  # 2
global___AuxSolnFileType = AuxSolnFileType

class FieldRange(google.protobuf.message.Message):
    """min and max range of a given solution field. For non-scalar quantities, the
    range of the magnitude field will be stored at the end of the min/max arrays.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MIN_FIELD_NUMBER: builtins.int
    MAX_FIELD_NUMBER: builtins.int
    @property
    def min(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.float]: ...
    @property
    def max(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.float]: ...
    def __init__(
        self,
        *,
        min: collections.abc.Iterable[builtins.float] | None = ...,
        max: collections.abc.Iterable[builtins.float] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["max", b"max", "min", b"min"]) -> None: ...

global___FieldRange = FieldRange

class AuxiliaryFile(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    URL_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    url: builtins.str
    type: global___AuxSolnFileType.ValueType
    def __init__(
        self,
        *,
        url: builtins.str = ...,
        type: global___AuxSolnFileType.ValueType = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["type", b"type", "url", b"url"]) -> None: ...

global___AuxiliaryFile = AuxiliaryFile

class SolnFileMetadata(google.protobuf.message.Message):
    """Datasets for the individual quantities are named based on the ID the
    respective quantity has in `proto.quantity.QuantityType`. E.g. for the volume
    data of Pressure its named `<zone_id>/2` and for boundary data
    `<zone_id>/bound/2`.

    SolnFileMetadata is stored in FileIndex.metadata.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MESH_URL_FIELD_NUMBER: builtins.int
    ZONE_FIELD_NUMBER: builtins.int
    VERSION_FIELD_NUMBER: builtins.int
    AUX_FILES_FIELD_NUMBER: builtins.int
    ITERATION_FIELD_NUMBER: builtins.int
    SIMULATION_TIME_FIELD_NUMBER: builtins.int
    mesh_url: builtins.str
    """The URL of the input mesh."""
    @property
    def zone(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___SolnZoneMetadata]:
        """Per-zone meta data"""
    version: builtins.int
    """Version of the solution file"""
    @property
    def aux_files(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___AuxiliaryFile]:
        """Auxiliary files for this particular solution"""
    iteration: builtins.int
    """Solver iteration associated with this solution."""
    simulation_time: builtins.float
    """Physical time associated with this solution.
    Meaningful for transient simulations only.
    """
    def __init__(
        self,
        *,
        mesh_url: builtins.str = ...,
        zone: collections.abc.Iterable[global___SolnZoneMetadata] | None = ...,
        version: builtins.int = ...,
        aux_files: collections.abc.Iterable[global___AuxiliaryFile] | None = ...,
        iteration: builtins.int = ...,
        simulation_time: builtins.float = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["aux_files", b"aux_files", "iteration", b"iteration", "mesh_url", b"mesh_url", "simulation_time", b"simulation_time", "version", b"version", "zone", b"zone"]) -> None: ...

global___SolnFileMetadata = SolnFileMetadata

class SolnZoneMetadata(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class BoundEntry(google.protobuf.message.Message):
        DESCRIPTOR: google.protobuf.descriptor.Descriptor

        KEY_FIELD_NUMBER: builtins.int
        VALUE_FIELD_NUMBER: builtins.int
        key: builtins.str
        @property
        def value(self) -> global___SolnBoundMetadata: ...
        def __init__(
            self,
            *,
            key: builtins.str = ...,
            value: global___SolnBoundMetadata | None = ...,
        ) -> None: ...
        def HasField(self, field_name: typing_extensions.Literal["value", b"value"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing_extensions.Literal["key", b"key", "value", b"value"]) -> None: ...

    NAME_FIELD_NUMBER: builtins.int
    BOUND_FIELD_NUMBER: builtins.int
    QUANTITY_FIELD_NUMBER: builtins.int
    RANGES_FIELD_NUMBER: builtins.int
    QUANTITY_FALLBACK_NAMES_FIELD_NUMBER: builtins.int
    name: builtins.str
    """Zone name"""
    @property
    def bound(self) -> google.protobuf.internal.containers.MessageMap[builtins.str, global___SolnBoundMetadata]:
        """Per-boundary meta data"""
    @property
    def quantity(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[luminarycloud._proto.quantity.quantity_pb2.QuantityType.ValueType]:
        """Solution quantities for the main grid"""
    @property
    def ranges(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___FieldRange]: ...
    @property
    def quantity_fallback_names(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Guard names used to identify DEBUG_QUANTITY quantities."""
    def __init__(
        self,
        *,
        name: builtins.str = ...,
        bound: collections.abc.Mapping[builtins.str, global___SolnBoundMetadata] | None = ...,
        quantity: collections.abc.Iterable[luminarycloud._proto.quantity.quantity_pb2.QuantityType.ValueType] | None = ...,
        ranges: collections.abc.Iterable[global___FieldRange] | None = ...,
        quantity_fallback_names: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["bound", b"bound", "name", b"name", "quantity", b"quantity", "quantity_fallback_names", b"quantity_fallback_names", "ranges", b"ranges"]) -> None: ...

global___SolnZoneMetadata = SolnZoneMetadata

class SolnBoundMetadata(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    QUANTITY_FIELD_NUMBER: builtins.int
    RANGES_FIELD_NUMBER: builtins.int
    QUANTITY_FALLBACK_NAMES_FIELD_NUMBER: builtins.int
    @property
    def quantity(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[luminarycloud._proto.quantity.quantity_pb2.QuantityType.ValueType]:
        """Solution quantities on the boundary"""
    @property
    def ranges(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___FieldRange]: ...
    @property
    def quantity_fallback_names(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """Guard names used to identify DEBUG_QUANTITY quantities."""
    def __init__(
        self,
        *,
        quantity: collections.abc.Iterable[luminarycloud._proto.quantity.quantity_pb2.QuantityType.ValueType] | None = ...,
        ranges: collections.abc.Iterable[global___FieldRange] | None = ...,
        quantity_fallback_names: collections.abc.Iterable[builtins.str] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["quantity", b"quantity", "quantity_fallback_names", b"quantity_fallback_names", "ranges", b"ranges"]) -> None: ...

global___SolnBoundMetadata = SolnBoundMetadata
