# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABCMeta
from dataclasses import dataclass, field
from typing import Any, Optional
from uuid import uuid4

from luminarycloud.tables import RectilinearTable, _param_name_to_table_type
from google.protobuf.message import Message as _Message

from luminarycloud.tables import RectilinearTable
from luminarycloud.types import Vector3
from luminarycloud.types.adfloat import _to_ad_proto, _from_ad_proto
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
import luminarycloud.params.enum._enum_wrappers as enum

from luminarycloud.params.param_wrappers._lib import ParamGroupWrapper, create_unique_id


@dataclass(kw_only=True)
class MaterialSolid(ParamGroupWrapper[clientpb.MaterialSolid]):
    """Configuration for Solid materials"""

    density: float = 2700
    "Constant density value."
    specific_heat_cp: float = 896
    "Specific heat at constant pressure."
    thermal_conductivity: float = 167
    "The thermal conductivity of the material."
    thermal_conductivity_table: Optional[RectilinearTable] = None
    "Correlation between thermal conductivity and temperature."
    preset: enum.MaterialSolidPreset = enum.MaterialSolidPreset.CUSTOM_MATERIAL_SOLID
    "Select a predefined set of material properties or allow a custom set of properties."

    def _to_proto(self) -> clientpb.MaterialSolid:
        _proto = clientpb.MaterialSolid()
        _proto.constant_density_value_solid.CopyFrom(_to_ad_proto(self.density))
        _proto.specific_heat_cp_solid.CopyFrom(_to_ad_proto(self.specific_heat_cp))
        _proto.thermal_conductivity_constant_solid.CopyFrom(_to_ad_proto(self.thermal_conductivity))
        if self.thermal_conductivity_table is not None:
            if self.thermal_conductivity_table.table_type != _param_name_to_table_type(
                "thermal_conductivity_table_data"
            ):
                raise TypeError("Wrong TableType used for self.thermal_conductivity_table")
            _proto.thermal_conductivity_table_data = self.thermal_conductivity_table.id
        _proto.material_solid_preset = self.preset
        return _proto

    def _from_proto(self, proto: clientpb.MaterialSolid) -> None:
        self.density = _from_ad_proto(proto.constant_density_value_solid)
        self.specific_heat_cp = _from_ad_proto(proto.specific_heat_cp_solid)
        self.thermal_conductivity = _from_ad_proto(proto.thermal_conductivity_constant_solid)
        if proto.thermal_conductivity_table_data != "":
            self.thermal_conductivity_table = RectilinearTable(
                id=proto.thermal_conductivity_table_data,
                name=proto.thermal_conductivity_table_data,
                table_type=_param_name_to_table_type("thermal_conductivity_table_data"),
            )
        self.preset = enum.MaterialSolidPreset(proto.material_solid_preset)
        return None
