# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABCMeta
from dataclasses import dataclass, field
from typing import Any, Optional
from uuid import uuid4

from luminarycloud.tables import RectilinearTable, _param_name_to_table_type
from google.protobuf.message import Message as _Message

from luminarycloud.tables import RectilinearTable
from luminarycloud.types import Vector3
from luminarycloud.types.adfloat import _to_ad_proto, _from_ad_proto
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
import luminarycloud.params.enum._enum_wrappers as enum

from luminarycloud.params.param_wrappers._lib import ParamGroupWrapper, create_unique_id


@dataclass(kw_only=True)
class Output(ParamGroupWrapper[clientpb.Output]):
    """Solution output settings."""

    iters_per_output: int = 1000
    "Number of (pseudo) timesteps between successive full solution output. If &le;0, only the final solution is written."
    debug_output: enum.DebugOutput = enum.DebugOutput.SOLN_DEBUG_OUTPUT_OFF
    "Output debug fields in solution files."
    debug_output_interior_surface_data: enum.DebugOutputInteriorSurfaceData = (
        enum.DebugOutputInteriorSurfaceData.SOLN_DEBUG_OUTPUT_INT_SURF_DATA_OFF
    )
    "Copy the interior volume data into the surface data."

    def _to_proto(self) -> clientpb.Output:
        _proto = clientpb.Output()
        _proto.iters_per_output.value = self.iters_per_output
        _proto.debug_output = self.debug_output
        _proto.debug_output_interior_surface_data = self.debug_output_interior_surface_data
        return _proto

    def _from_proto(self, proto: clientpb.Output) -> None:
        self.iters_per_output = proto.iters_per_output.value
        self.debug_output = enum.DebugOutput(proto.debug_output)
        self.debug_output_interior_surface_data = enum.DebugOutputInteriorSurfaceData(
            proto.debug_output_interior_surface_data
        )
        return None
