# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABCMeta
from dataclasses import dataclass, field
from typing import Any, Optional
from uuid import uuid4

from luminarycloud.tables import RectilinearTable, _param_name_to_table_type
from google.protobuf.message import Message as _Message

from luminarycloud.tables import RectilinearTable
from luminarycloud.types import Vector3
from luminarycloud.types.adfloat import _to_ad_proto, _from_ad_proto
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
import luminarycloud.params.enum._enum_wrappers as enum

from luminarycloud.params.param_wrappers._lib import ParamGroupWrapper, create_unique_id

from luminarycloud.params.param_wrappers.simulation_param.physics.fluid.boundary_conditions.inlet_ import (
    Inlet,
)
from luminarycloud.params.param_wrappers.simulation_param.physics.fluid.boundary_conditions.inlet_ import *


@dataclass(kw_only=True)
class TotalPressureInlet(Inlet):
    """Total pressure inlet boundary condition."""

    total_pressure: float = 101325
    "Total pressure at the boundary relative to the material reference pressure."
    total_pressure_column_index: int = 0
    "Index of the column of the table in profile_bc_data for total pressure"
    direction_specification: enum.DirectionSpecification = (
        enum.DirectionSpecification.NORMAL_TO_BOUNDARY
    )
    "Method of defining the flow direction at the inlet."
    direction: Vector3 = field(default_factory=lambda: Vector3(1.0, 0.0, 0.0))
    "Vector (x,y,z) defining the flow direction. Automatically scaled to a unit vector internally."

    def _to_proto(self) -> clientpb.BoundaryConditionsFluid:
        _proto = super()._to_proto()
        _proto.inlet_momentum = enum.InletMomentum.TOTAL_PRESSURE_INLET
        _proto.total_pressure.CopyFrom(_to_ad_proto(self.total_pressure))
        _proto.total_pressure_col.value = self.total_pressure_column_index
        _proto.direction_specification = self.direction_specification
        _proto.flow_direction.CopyFrom(self.direction._to_ad_proto())
        return _proto

    def _from_proto(self, proto: clientpb.BoundaryConditionsFluid) -> None:
        super()._from_proto(proto)
        assert proto.inlet_momentum == enum.InletMomentum.TOTAL_PRESSURE_INLET
        self.total_pressure = _from_ad_proto(proto.total_pressure)
        self.total_pressure_column_index = proto.total_pressure_col.value
        self.direction_specification = enum.DirectionSpecification(proto.direction_specification)
        self.direction._from_ad_proto(proto.flow_direction)
        return None
