# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABCMeta
from dataclasses import dataclass, field
from typing import Any, Optional
from uuid import uuid4

from luminarycloud.tables import RectilinearTable, _param_name_to_table_type
from google.protobuf.message import Message as _Message

from luminarycloud.tables import RectilinearTable
from luminarycloud.types import Vector3
from luminarycloud.types.adfloat import _to_ad_proto, _from_ad_proto
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
import luminarycloud.params.enum._enum_wrappers as enum

from luminarycloud.params.param_wrappers._lib import ParamGroupWrapper, create_unique_id

from luminarycloud.params.param_wrappers.simulation_param.physics.heat.boundary_conditions_heat_ import (
    BoundaryConditionsHeat,
)
from luminarycloud.params.param_wrappers.simulation_param.physics.heat.boundary_conditions_heat_ import *


@dataclass(kw_only=True)
class HeatBcConvection(BoundaryConditionsHeat):
    """Convective heat transfer."""

    fluid_temperature: float = 288.15
    "Temperature at the wall boundary surfaces."
    heat_transfer_coefficient: float = 0.0
    "Heat transfer coefficient for convective heat transfer. Allowed range [0, infinity)."

    def _to_proto(self) -> clientpb.BoundaryConditionsHeat:
        _proto = super()._to_proto()
        _proto.heat_physical_boundary = enum.HeatPhysicalBoundary.HEAT_BC_CONVECTION
        _proto.fixed_temperature.CopyFrom(_to_ad_proto(self.fluid_temperature))
        _proto.heat_transfer_coefficient.CopyFrom(_to_ad_proto(self.heat_transfer_coefficient))
        return _proto

    def _from_proto(self, proto: clientpb.BoundaryConditionsHeat) -> None:
        super()._from_proto(proto)
        assert proto.heat_physical_boundary == enum.HeatPhysicalBoundary.HEAT_BC_CONVECTION
        self.fluid_temperature = _from_ad_proto(proto.fixed_temperature)
        self.heat_transfer_coefficient = _from_ad_proto(proto.heat_transfer_coefficient)
        return None
