# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABCMeta
from dataclasses import dataclass, field
from typing import Any, Optional
from uuid import uuid4

from luminarycloud.tables import RectilinearTable, _param_name_to_table_type
from google.protobuf.message import Message as _Message

from luminarycloud.tables import RectilinearTable
from luminarycloud.types import Vector3
from luminarycloud.types.adfloat import _to_ad_proto, _from_ad_proto
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
import luminarycloud.params.enum._enum_wrappers as enum

from luminarycloud.params.param_wrappers._lib import ParamGroupWrapper, create_unique_id


@dataclass(kw_only=True)
class SpatialDiscretizationHeat(ParamGroupWrapper[clientpb.SpatialDiscretizationHeat]):
    """Spatial discretization settings for a heat transfer physics solver."""

    gradient_method: enum.GradientMethod = enum.GradientMethod.NODAL_GRADIENT
    "Method for computing the spatial gradients of fluid variables."
    hlsq_blend: float = 2.0
    "Blending parameter in the hybrid least squares gradient methods in [1,2]."
    geometry_fixes: enum.GeometryFixes = enum.GeometryFixes.GEOMETRY_FIXES_ON
    "Strategies to cope with problematic mesh regions (e.g. high skewness angles)."
    geometry_fixes_mitigations: float = 0.25
    "Magnitude of the geometrical fixes mitigations. Expected value within [0,1]. The higher this value, the more numerical dissipation is added at control volumes with low-quality topological properties."
    preset: enum.SpatialDiscretizationHeatPreset = (
        enum.SpatialDiscretizationHeatPreset.DEFAULT_SPATIAL_DISCRETIZATION_HEAT
    )
    "Select suggested control settings or allow a custom choice. In general, assume a trade-off between accuracy and robustness (i.e. the ability to converge)."

    def _to_proto(self) -> clientpb.SpatialDiscretizationHeat:
        _proto = clientpb.SpatialDiscretizationHeat()
        _proto.gradient_method = self.gradient_method
        _proto.hlsq_blend.CopyFrom(_to_ad_proto(self.hlsq_blend))
        _proto.geometry_fixes = self.geometry_fixes
        _proto.geometry_fixes_mitigations.CopyFrom(_to_ad_proto(self.geometry_fixes_mitigations))
        _proto.spatial_discretization_heat_preset = self.preset
        return _proto

    def _from_proto(self, proto: clientpb.SpatialDiscretizationHeat) -> None:
        self.gradient_method = enum.GradientMethod(proto.gradient_method)
        self.hlsq_blend = _from_ad_proto(proto.hlsq_blend)
        self.geometry_fixes = enum.GeometryFixes(proto.geometry_fixes)
        self.geometry_fixes_mitigations = _from_ad_proto(proto.geometry_fixes_mitigations)
        self.preset = enum.SpatialDiscretizationHeatPreset(proto.spatial_discretization_heat_preset)
        return None
